// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'collistb.pas' rev: 3.00

#ifndef collistbHPP
#define collistbHPP
#include <Menus.hpp>
#include <Forms.hpp>
#include <Dialogs.hpp>
#include <StdCtrls.hpp>
#include <Controls.hpp>
#include <Graphics.hpp>
#include <Classes.hpp>
#include <SysUtils.hpp>
#include <Messages.hpp>
#include <Windows.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Collistb
{
//-- type declarations -------------------------------------------------------
enum TColumnType { ctText, ctImage };

class DELPHICLASS TListBoxColumnItem;
class PASCALIMPLEMENTATION TListBoxColumnItem : public Classes::TCollectionItem 
{
	typedef Classes::TCollectionItem inherited;
	
private:
	int fWidth;
	TAlignment fAlignment;
	Graphics::TFont* fFont;
	Graphics::TColor fColor;
	TColumnType fColumnType;
	void __fastcall SetWidth(const int value);
	void __fastcall SetAlignment(const Classes::TAlignment value);
	void __fastcall SetFont(const Graphics::TFont* value);
	void __fastcall SetColor(const Graphics::TColor value);
	void __fastcall SetColumnType(const TColumnType Value);
	
protected:
	virtual System::AnsiString __fastcall GetDisplayName();
	
public:
	__fastcall virtual TListBoxColumnItem(Classes::TCollection* Collection);
	__fastcall virtual ~TListBoxColumnItem(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	
__published:
	__property Graphics::TColor Color = {read=fColor, write=SetColor, nodefault};
	__property TColumnType ColumnType = {read=fColumnType, write=SetColumnType, nodefault};
	__property int Width = {read=fWidth, write=SetWidth, nodefault};
	__property Classes::TAlignment Alignment = {read=fAlignment, write=SetAlignment, nodefault};
	__property Graphics::TFont* Font = {read=fFont, write=SetFont};
};

class DELPHICLASS TListBoxColumnCollection;
class DELPHICLASS TColumnListBox;
class DELPHICLASS TListBoxItemCollection;
class DELPHICLASS TListBoxItem;
class PASCALIMPLEMENTATION TListBoxItemCollection : public Classes::TCollection 
{
	typedef Classes::TCollection inherited;
	
private:
	TColumnListBox* fOwner;
	HIDESBASE TListBoxItem* __fastcall GetItem(int Index);
	HIDESBASE void __fastcall SetItem(int Index, const TListBoxItem* Value);
	
protected:
	virtual void __fastcall Update(Classes::TCollectionItem* Item);
	
public:
	HIDESBASE TListBoxItem* __fastcall Add(void);
	HIDESBASE TListBoxItem* __fastcall Insert(int index);
	__property TListBoxItem* Items[int Index] = {read=GetItem, write=SetItem};
	__fastcall TListBoxItemCollection(TColumnListBox* aOwner);
	DYNAMIC Classes::TPersistent* __fastcall GetOwner(void);
public:
	/* TCollection.Destroy */ __fastcall virtual ~TListBoxItemCollection(void) { }
	
};

class PASCALIMPLEMENTATION TColumnListBox : public Stdctrls::TCustomListBox 
{
	typedef Stdctrls::TCustomListBox inherited;
	
private:
	Controls::TImageList* fImages;
	TListBoxColumnCollection* fColumns;
	TListBoxItemCollection* fListBoxItems;
	bool fGridLines;
	int fItemIndex;
	int fUpdateCount;
	void __fastcall SetImages(const Controls::TImageList* Value);
	HIDESBASE void __fastcall SetItemIndex(const int Value);
	HIDESBASE int __fastcall GetItemIndex(void);
	void __fastcall SetGridLines(const bool Value);
	void __fastcall BuildItems(void);
	
protected:
	virtual void __fastcall MeasureItem(int Index, int &Height);
	virtual void __fastcall DrawItem(int Index, const Windows::TRect &Rect, Stdctrls::TOwnerDrawState State
		);
	virtual void __fastcall CreateWnd(void);
	virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation AOperation
		);
	__property Items ;
	
public:
	__fastcall virtual TColumnListBox(Classes::TComponent* AOwner);
	__fastcall virtual ~TColumnListBox(void);
	virtual void __fastcall Loaded(void);
	__property Text ;
	void __fastcall BeginUpdate(void);
	void __fastcall EndUpdate(void);
	
__published:
	__property Align ;
	__property BorderStyle ;
	__property Color ;
	__property Cursor ;
	__property Ctl3D ;
	__property TListBoxColumnCollection* Columns = {read=fColumns, write=fColumns};
	__property TListBoxItemCollection* ListBoxItems = {read=fListBoxItems, write=fListBoxItems};
	__property DragCursor ;
	__property DragMode ;
	__property Enabled ;
	__property Font ;
	__property bool GridLines = {read=fGridLines, write=SetGridLines, nodefault};
	__property Controls::TImageList* Images = {read=fImages, write=SetImages};
	__property IntegralHeight ;
	__property ItemHeight ;
	__property int ItemIndex = {read=GetItemIndex, write=SetItemIndex, nodefault};
	__property MultiSelect ;
	__property ParentColor ;
	__property ParentCtl3D ;
	__property ParentFont ;
	__property ParentShowHint ;
	__property PopupMenu ;
	__property ShowHint ;
	__property Sorted ;
	__property TabOrder ;
	__property TabStop ;
	__property Visible ;
	__property OnClick ;
	__property OnDblClick ;
	__property OnDragDrop ;
	__property OnDragOver ;
	__property OnDrawItem ;
	__property OnEndDrag ;
	__property OnEnter ;
	__property OnExit ;
	__property OnKeyDown ;
	__property OnKeyPress ;
	__property OnKeyUp ;
	__property OnMeasureItem ;
	__property OnStartDrag ;
public:
	/* TWinControl.CreateParented */ __fastcall TColumnListBox(HWND ParentWindow) : Stdctrls::TCustomListBox(
		ParentWindow) { }
	
};

class PASCALIMPLEMENTATION TListBoxColumnCollection : public Classes::TCollection 
{
	typedef Classes::TCollection inherited;
	
private:
	TColumnListBox* fOwner;
	HIDESBASE TListBoxColumnItem* __fastcall GetItem(int Index);
	HIDESBASE void __fastcall SetItem(int Index, const TListBoxColumnItem* Value);
	
protected:
	virtual void __fastcall Update(Classes::TCollectionItem* Item);
	
public:
	HIDESBASE TListBoxColumnItem* __fastcall Add(void);
	HIDESBASE TListBoxColumnItem* __fastcall Insert(int index);
	__property TListBoxColumnItem* Items[int Index] = {read=GetItem, write=SetItem};
	__fastcall TListBoxColumnCollection(TColumnListBox* aOwner);
	DYNAMIC Classes::TPersistent* __fastcall GetOwner(void);
public:
	/* TCollection.Destroy */ __fastcall virtual ~TListBoxColumnCollection(void) { }
	
};

class PASCALIMPLEMENTATION TListBoxItem : public Classes::TCollectionItem 
{
	typedef Classes::TCollectionItem inherited;
	
private:
	int fImageIndex;
	Classes::TStringList* fStrings;
	int fTag;
	void __fastcall SetImageIndex(const int value);
	void __fastcall SetStrings(const Classes::TStringList* Value);
	void __fastcall StringsChanged(System::TObject* sender);
	
protected:
	virtual System::AnsiString __fastcall GetDisplayName();
	
public:
	__fastcall virtual TListBoxItem(Classes::TCollection* Collection);
	__fastcall virtual ~TListBoxItem(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	
__published:
	__property int ImageIndex = {read=fImageIndex, write=SetImageIndex, nodefault};
	__property Classes::TStringList* Strings = {read=fStrings, write=SetStrings};
	__property int Tag = {read=fTag, write=fTag, nodefault};
};

//-- var, const, procedure ---------------------------------------------------
extern PACKAGE void __fastcall Register(void);

}	/* namespace Collistb */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Collistb;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// collistb
